#define rpa_activate
/*
rpa_activate(key,code,[dll path])
Activates the application and saves the Product Key.
Key is the Product Key and Code is the Security code.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument2) then RPA_DLL=argument2;
RPA_Activate=       external_define(RPA_DLL,"RPA_Activate_GM",       dll_stdcall,ty_real,3,ty_string,ty_real,ty_string)
result=external_call(RPA_Activate,argument0,game_id,argument1);
external_free(RPA_Activate);
return result
#define rpa_activation_wizard
/*
rpa_activation_wizard(appname,code,[wizard path])
Shows the activation wizard, which helps the user to activate the application.
appname is the Application's name, which is shown in the wizard.
Returns 0 if activation failed, 1 if activation successed or -1 if the given wizard path (if any), activation_wizard.exe, activation.exe and activate.exe don't exist.
*/
if is_string(argument2) and file_exists(argument2) {
execute_program(argument2,'/name:'+string_replace_all(string(argument0),' ','_')+' /id:'+string(game_id)+' /code:'+string(argument1),true);
return rpa_check_activated();
} else {
if file_exists('activation_wizard.exe') {
execute_program('activation_wizard.exe','/name:'+string_replace_all(string(argument0),' ','_')+' /id:'+string(game_id)+' /code:'+string(argument1),true);
return rpa_check_activated();
} else {
if file_exists('activation.exe') {
execute_program('activation.exe','/name:'+string_replace_all(string(argument0),' ','_')+' /id:'+string(game_id)+' /code:'+string(argument1),true);
return rpa_check_activated();
} else {
if file_exists('activate.exe') {
execute_program('activate.exe','/name:'+string_replace_all(string(argument0),' ','_')+' /id:'+string(game_id)+' /code:'+string(argument1),true);
return rpa_check_activated();
} else {
return -1;
}}}}
#define rpa_check_activated
/*
rpa_check_activated([dll path])
Returns if the application is activated.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument0) then RPA_DLL=argument0;
RPA_Check_Activated=external_define(RPA_DLL,"RPA_Check_Activated_GM",dll_stdcall,ty_real,1,ty_real                    )
result=external_call(RPA_Check_Activated,game_id);
external_free(RPA_Check_Activated);
return result
#define rpa_check_key
/*
rpa_check_key(key,[dll path])
Returns if the given key is a valid Product Key.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument1) then RPA_DLL=argument1;
RPA_Check_Key=      external_define(RPA_DLL,"RPA_Check_Key_GM",      dll_stdcall,ty_real,2,ty_string,ty_real          )
result=external_call(RPA_Check_Key,argument0,game_id);
external_free(RPA_Check_Key);
return result
#define rpa_deactivate
/*
rpa_deactivate([dll path])
Deactivates the application. The Product Key is still saved.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument0) then RPA_DLL=argument0;
RPA_Deactivate=     external_define(RPA_DLL,"RPA_Deactivate_GM",     dll_stdcall,ty_real,1,ty_real                    )
result=external_call(RPA_Deactivate,game_id);
external_free(RPA_Deactivate);
return result
#define rpa_get_key
/*
rpa_get_key([dll path])
Returns the saved Product Key or an empty string if no Product Key found.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument0) then RPA_DLL=argument0;
RPA_Get_Key=        external_define(RPA_DLL,"RPA_Get_Key_GM",        dll_stdcall,ty_real,1,ty_real                    )
var key, f;
external_call(RPA_Get_Key,game_id);
f=file_text_open_read(environment_get_variable('Userprofile')+'\key.txt');
key=file_text_read_string(f);
file_text_close(f);
file_delete(environment_get_variable('Userprofile')+'\key.txt');
external_free(RPA_Get_Key);
return key;
#define rpa_save_key
/*
rpa_save_key(key,[dll path])
Saves the key argument as Product Key without activating it.
*/
RPA_DLL=working_directory+"\RPA.dll";
if file_exists(RPA_DLL)=0 then RPA_DLL=temp_directory+"\RPA.dll";
if is_string(argument1) then RPA_DLL=argument1;
RPA_Save_Key=       external_define(RPA_DLL,"RPA_Save_Key_GM",       dll_stdcall,ty_real,2,ty_string,ty_real          )
if is_string(argument0) {
result=external_call(RPA_Save_Key,argument0,game_id);
external_free(RPA_Save_Key);
return result;
} else return false;
